\ dstro_menu.fs -- LCD menu fo dstro app. -- 21Apr14 rjn
\ 
]  here ( *start)
0 [if] \ --------------------- Notes ------------------------------------------
\ 
1. Uses xvalues  bxtable0, 1, 2, 3, 4 and 5
2. Some code commented out that may be useful for a wider range vfo.
\ 
[then] \ ----------------------------------------------------------------------
\ -: h.wait  0lcd  h.lcd ( flutter) ?ie-down  ?switch-up ;
\ -: depth.lcd   depth 0=if drop ; then drop h.wait ;
\ -: persist  led-off  13 #  7 #for  80ms-delay  7 #next ;
\ -: 'set  lstring "  set!"

-: ?.sopt   /line2  ?.sduty  2 # n_lcd
   @bx3 0=if drop ?.srate=hertz ; then drop ?.srate=rpm ;
\ 
1 [if] \ ----------------------------------------------------------------------
\ 
\ -----[ duty cycle menu ]
\ 
-: save-duty-choice     @option    !bx6 ;
-: restore-duty-choice  @bx6  !option  ;

-: '>duty  lstring " >duty"
-: .duty-choice  /line2 4 # n_lcd '>duty ;

-: 'duty-menu  lstring " Duty Cycle Menu"
-: .duty-menu  /line1 1 # n_lcd 'duty-menu ;

-: set.duty  ?duty  ?.duty ;
-: >10%   !10% set.duty ; 
-: >20%   !20% set.duty ;
-: >30%   !30% set.duty ; 
-: >40%   !40% set.duty ;
-: >50%   !50% set.duty ; 
-: >60%   !60% set.duty ;
-: >70%   !70% set.duty ; 
-: >80%   !80% set.duty ; 
-: >90%   !90% set.duty ; 

:m ?xduty  ( n - n)  
   |9xor 0=if drop xback ; then |9xor  save-duty-choice m;

-: xduty   @1of10  ?xduty
         0=if drop >10% xback ; then
   |1xor 0=if drop >20% xback ; then |1xor
   |2xor 0=if drop >30% xback ; then |2xor
   |3xor 0=if drop >40% xback ; then |3xor
   |4xor 0=if drop >50% xback ; then |4xor
   |5xor 0=if drop >60% xback ; then |5xor
   |6xor 0=if drop >70% xback ; then |6xor
   |7xor 0=if drop >80% xback ; then |7xor
   |8xor 0=if drop >90% xback ; then drop ;

-: duty-menu   @1of10 ?shown
         0=if drop .10%  ; then 
   |1xor 0=if drop .20%  ; then |1xor
   |2xor 0=if drop .30%  ; then |2xor
   |3xor 0=if drop .40%  ; then |3xor
   |4xor 0=if drop .50%  ; then |4xor
   |5xor 0=if drop .60%  ; then |5xor
   |6xor 0=if drop .70%  ; then |6xor
   |7xor 0=if drop .80%  ; then |7xor
   |8xor 0=if drop .90%  ; then |8xor
   |9xor 0=if drop .back ; then drop ;

-: do-duty 
   begin duty-menu ?activity ie-switch 0=until. ?switch-up 
   xduty ;

-: >duty   /back  /last  .duty-menu  restore-duty-choice  
   0 # begin drop  do-duty back? until drop ;
   \ 
[then] \ ----------------------------------------------------------------------   
\ 
\ -----[ rate menu ]
\ 
-: save-rate-choice     @option    !bx1 ;
-: restore-rate-choice  @bx1  !option  ;

-: 'rate  lstring " >rate"
-: .rate-choice  /line2 4 # n_lcd 'rate ;

-: 'rate-menu  lstring " Rate Menu"
-: .rate-menu  /line1 3 # n_lcd 'rate-menu ;

-: set.rate  ?rate    ?.rate ;
-: >0.01hz   !0.01hz  ?.rate ; 
-: >0.1hz    !0.1hz   ?.rate ; 
-: >1hz      !1hz     ?.rate ; 
-: >10hz     !10hz    ?.rate ;
-: >100hz    !100hz   ?.rate ;

:m ?xrate  ( n - n)  
   |5xor 0=if drop xback ; then |5xor  save-rate-choice m;

-: xrate   @1of6  ?xrate
         0=if drop >0.01hz xback ; then
   |1xor 0=if drop >0.1hz  xback ; then |1xor
   |2xor 0=if drop >1hz    xback ; then |2xor
   |3xor 0=if drop >10hz   xback ; then |3xor
   |4xor 0=if drop >100hz  xback ; then drop ;
\ 
-: rate-menu   @1of6 ?shown
         0=if drop .0.01hz ; then 
   |1xor 0=if drop .0.1hz  ; then |1xor
   |2xor 0=if drop .1hz    ; then |2xor
   |3xor 0=if drop .10hz   ; then |3xor
   |4xor 0=if drop .100hz  ; then |4xor
   |5xor 0=if drop .back   ; then drop ;
\ 
-: do-rate 
   begin rate-menu ?activity ie-switch 0=until. ?switch-up 
   xrate ;

-: >rate   /back  /last  .rate-menu  restore-rate-choice  
   0 # begin drop  do-rate back? until drop ;
\  
\ -----[ units menu ]
\ 
\ --- unit strings
\ 
-: save-units-choice     @option    !bx2 ;
-: restore-units-choice  @bx2  !option  ;

-: 'units-menu  lstring " Units Menu"
-: 'units  lstring " >units"
-: .units-choice  /line2 4 # n_lcd  'units ;
-: .units-menu   /line1  2 # n_lcd  'units-menu ;
\ 
-: 'units=hertz  lstring " >Hertz"
\ -: 'hertz-set    lstring " Hertz set!"
-: .units=hertz  /line2 4 # n_lcd 'units=hertz ;
\ use bxtable3 for Hertz/rpm value: 0=Hertz, 1=rpm
-: >units=hertz  /line2  0 # !bx3  ?.units 'set  persist ; 


-: 'units=rpm  lstring " >rpm"
\ -: 'rpm  lstring "  rpm"
-: .units=rpm  /line2  4 # n_lcd 'units=rpm ;
\ -: 'rpm-set  lstring " rpm set!"
-: >units=rpm  /line2  1 # !bx3  ?.units 'set persist ;
\ 
:m ?xunits  ( n - n)  
   |2xor 0=if drop xback ; then |2xor  
   save-units-choice m;

-: xunits   @1of3  ?xunits
         0=if drop >units=hertz xback ; then
   |1xor 0=if drop >units=rpm   xback ; then drop ;

-: units-menu   @1of3 ?shown
         0=if drop .units=hertz ; then 
   |1xor 0=if drop .units=rpm   ; then |1xor
   |2xor 0=if drop .back        ; then drop ;

-: do-units 
   begin units-menu ?activity ie-switch 0=until. ?switch-up 
   xunits ;
\ 
-: >units   /back  /last  .units-menu  restore-units-choice  
   0 # begin drop  do-units back? until drop ;
\ 
\ -----[ main menu loop ]
\ 
-: xmain  @1of4
         0=if drop >rate  ; then
   |1xor 0=if drop >units ; then |1xor
   |2xor 0=if drop >duty  ; then |2xor
   |3xor 0=if drop xback  ; then drop ;
  
-: save-main-choice     ( - n)  @option    !bx0 ; 
-: restore-main-choice  ( n -)  @bx0  !option   ;

-: 'main-menu  lstring " Option Menu" ;
-: .main-menu  /line1 lcd-coff 2 # n_lcd 'main-menu ;

-: ?select  
   ie-switch 0=if. ?switch-up
\     s.lcd  \ debug
      save-main-choice
      xmain
      restore-main-choice
      .main-menu  /last
\      s.lcd  \ debug
   then ;

-: /main-menu   restore-main-choice  /last  /back /ie-step ;

-: main-options  line2  @1of4 ?shown
         0=if drop .rate-choice   ; then 
   |1xor 0=if drop .units-choice  ; then |1xor
   |2xor 0=if drop .duty-choice   ; then |2xor
   |3xor 0=if drop .back          ; then drop ;

: main-menu   /main-menu  .main-menu 
   0 # begin  drop main-options ?activity  ?select  back? until drop  
   ?.sopt  ?rate  erase-config  save-xtable ?switch-up ;

here ( *stop)  [ swap -  cr .( dstro_menu.fs     ) . .( bytes) ]

\  
\ 
0 [if] ------------------------[ revisions ]-----------------------------------
\ 
Date	  By  Comment
======= === ===================================================================
21Apr14 rjn changed name preparing for production release
18Mar14 rjn added duty cycle menu
04Mar14 rjn working version with both rates and units
20Feb14 rjn cloned from sudds for dstro
23Apr13 rjn complete rework for sx-146 bands
16Apr13 rjn more send work
13Apr13 rjn modifications for send 
30Apr10 rjn outlined save/restore from flash (not implemented)
05Dec09 rjn added review option to report submenu
01Dec09 rjn stubbed out EPUT mode menu
23Nov09 rjn improved timer menu, one-shot sub-menu, |1xor vs. 1xor (etc.)
18Nov09 rjn added timer menu
12Nov09 rjn added report menu (note improved 7-options)
24Sep09 rjn added clock and run menus
21Sep09 rjn initial version -- cloned from Warbler menu
\ 
[then] \ ----------------------------------------------------------------------
