\ ie.fs -- strobe incremental encoder -- 14Mar14 rjn
\ 
\ 
] here ( *start)
\
\ 
0 [if] \ --------------------[ switch utilities ]------------------------------
\
\ ----- FYI 
:m ie-switch   [ 0 .P2 ] m;  \ encoder switch
:m iea         [ 7 .P0 ] m;  \ encoder phase a
:m ieb         [ 6 .P0 ] m;  \ encoder phase b
\ 
\ switch reading, debounce, etc.
\ 
\ :m 80ms-delay  $0a # delay765 m;  \ debounce delay
:m 80ms-delay  80 # ms m;
\ : test-80ms  begin 80ms-delay ~cbit again
\ 
\ --- continue on switch up and down
-: ?ie-up    begin 80ms-delay ie-switch until.   ;  \ continue if ie-switch is up
-: ?ie-down  begin 80ms-delay ie-switch 0=until. ;  \ continue if ie-switch is down
-: ?switch-up  ?ie-up 100 # ms ;  \ with debounce
\  
[then] \ ----------------------------------------------------------------------
\ 

:m |switch?  ( - ?)   ie-switch if. 0 # ; then $ff # m; \ flag based on sw pos.
-: switch?  ( - ?)   |switch? ;  \ debug
\ : stest   begin  do-stuff  switch? 0=until. ;  \ klunky example
\ 
\ ----- [ allocate ie accumulators, variables ]
\ 
cpuHERE constant ie-acc  4 cpuALLOT  \ ie-acc is MSB, ie-acc3 is LSB

:m ie-acc1  [ ie-acc 1 + ] m;
:m ie-acc2  [ ie-acc 2 + ] m;
:m ie-acc3  [ ie-acc 3 + ] m;

:m |0ie-acc  ie-acc #  zero4 m;
-: 0ie-acc  |0ie-acc ;

\ use these in main loop
-: @ie-acc  ( - q)  -int ie-acc # @quad< +int ;
-: !ie-acc  ( q -)  -int ie-acc # !quad  +int ; 

:m |option   ie-acc3 m;
:m |option1  ie-acc2 m;
-: @option  ( - n)  |option  #@ ;
-: !option  ( n -)  |option  #! ;
-: @option1 ( - n)  |option1 #@ ;
-: !option1 ( n -)  |option1 #! ;
-: @doption   @option  @option1 ;  \ get last two bytes of ie accumulator
-: !doption  ( lsb msb - )   [ ie-acc 2 + ] #!  |option #! ;
\ 
\ -----[ ie utilities for menu ]
\ 
\ cpuHERE constant spacing 1 cpuALLOT
\ 6 constant spacing   \ how far to move before next option
\ : mod-option   ( - n)   @option spacing #@ u/mod nip ;
\ 
\ --- check for option change or switch closure
\ note: cmd? can't be a macro ( ; exits ?change)
-: cmd?  ie-switch 0=if. $ff # ; then $00 # ;
\ 

0 [if] \ ------------[ detect option change & switch release ]-----------------
-: ?change   
   mod-option dup  begin 
      drop mod-option |over xor cmd? ior 
   until drop drop ;
[then] \ ----------------------------------------------------------------------
\ 
1 [if] \ ----------------------[ menu utilities ]------------------------------
\ 
-: ?activity  \ exits if switch or ie activity 
   @option dup begin
      drop  @option |over xor  cmd? ior
   until drop drop ;
\
-: ?changed   \ see if anything has changed
  ?activity  \ wait for switch or option change
  cmd? if drop ; then drop ; \ exit if change is switch
\ 
[then] \ ----------------------------------------------------------------------
\ 
\ 
\ -----[ ie accumulator and "changed" cells ]
\  
cpuHERE constant ie-old  1 cpuALLOT  \ holds old ie bits
\ cpuHERE constant ie-new  1 cpuALLOT  \ holds new ie bits 

cpuHERE constant ie-step 4 cpuALLOT  \ ie-step is MSB, ie-step 3 + is LSB
:m ie-step3  [ ie-step 3 + ] m;
:m ie-step2  [ ie-step 2 + ] m;
:m ie-step1  [ ie-step 1 + ] m;

-: 0ie-step  ie-step # zero4 ;

-: /ie-step       0ie-step    1 # ie-step3 #! ; 
-: /ie-step10     0ie-step   10 # ie-step3 #! ;
-: /ie-step100    0ie-step  100 # ie-step3 #! ;
-: /ie-step1k     0ie-step  $03 # ie-step2 #!  
                            $E8 # ie-step3 #! ;  \   1000 = $0003E8
-: /ie-step10k    0ie-step  $27 # ie-step2 #!  
                            $10 # ie-step3 #! ;  \  10000 = $002710
-: /ie-step100k   0ie-step  $01 # ie-step1 #!  
                            $86 # ie-step2 #! 
                            $a0 # ie-step3 #! ;  \ 100000 = $0186a0
\ 
\ -----[ encoder read and update ]
\ 
-: @ie-old  ( - n)   ie-old #@ ;
:m |!ie-old  ( n - n)   [ t ie-old mov ] m;
-: !ie-old  |!ie-old ;
:m |@ie  ( - n)   0 # [ iea movbc rlc  ieb movbc rlc ] m;
-: @ie  |@ie ;
:m ie-change?  ( - ?)   |@ie  @ie-old  xor m;
:m |ie-changed?  ( - ?)   |@ie  @ie-old  xor  |@ie |!ie-old drop m;
-: ie-changed?  |ie-changed? ;

\ : ?ie-change  0 # begin drop  ie-change? ie-until drop ;
\ 
\ : (rate-test)   ie-changed? if [ 1 .P0 toggle ] drop ; then drop ;
\ : rate-test   begin (rate-test) again ;
\ 
\ : lcd.4h   4 #  [ 4 push ] 4 #for @+ h.lcd 4 #next [ 4 pop ] ;
\ : lcd.ie-acc    lcd-home  ie-acc  # a!  lcd.4h ;
\ -: lcd.ie-step   lcd-home  ie-step # a!  lcd.4h ;
\ 
\ 
\ -----[ Increment, Decrement encoder accumulators ]
\ 
:m |ie-increment
	[ t push  clrc
        	ie-acc3 t mov  ie-step3 addc  t ie-acc3 mov
         ie-acc2 t mov  ie-step2 addc  t ie-acc2 mov
        	ie-acc1 t mov  ie-step1 addc  t ie-acc1 mov
        	ie-acc  t mov  ie-step  addc  t ie-acc  mov
     t pop ]
m;

\ [ : subb  dup 8 < if $98 + ] , [ exit then $95 ] , , [ ; ]  \ now in misc8051.fs

:m |ie-decrement
	[ t push  clrc
        	ie-acc3 t mov  ie-step3 subb  t ie-acc3 mov
         ie-acc2 t mov  ie-step2 subb  t ie-acc2 mov
        	ie-acc1 t mov  ie-step1 subb  t ie-acc1 mov
        	ie-acc  t mov  ie-step  subb  t ie-acc  mov
     t pop ]
m;
\ 
\ -----[ ie updates ]
\ 
:m |?ie-bump   
   |@ie [ rlc ] ie-old #@ xor 
   1 .t if. |ie-increment drop ; 
       then |ie-decrement drop  m;
-: ?ie-bump  |?ie-bump ;

:m |ie-transfer   |@ie |!ie-old drop m;
 
\ -------------------------[ band limit checking ]-----------------------------
\ 
-: ie>gp0  @ie-acc  gp0 # !quad  ;
-: ie>gp4  @ie-acc  gp4 # !quad  ; 
-: gp0>ie  gp0 # @quad<  !ie-acc ;

here constant band-table
here ( *)
\  
\ msb ------------- lsb      band   freq limit  
\                            ---- --------------
\ 
$00 , $00 , $c3 , $50 ,      \ 0u 500 Hertz (50,000)
$00 , $00 , $00 , $01 ,      \ 0l 0.01 Hertz
\ 
\ calculate actual number of items in band limit table (e.g., for clip, display)
here ( *) [ swap - 2/ 2/ ] constant #btable
\ 
-: @band-table  ( index - q) \ get quad from band limit table
  push band-table ## pop ai>qadr @qflash< ;
\ 
\ 
cpuHERE constant upper0  1 cpuALLOT  \ msB of upper limit
cpuHERE constant upper1  1 cpuALLOT  \ 
cpuHERE constant upper2  1 cpuALLOT  \ 
cpuHERE constant upper3  1 cpuALLOT  \ lsB of upper limit
\ 
cpuHERE constant lower0  1 cpuALLOT  \ msB of lower limit
cpuHERE constant lower1  1 cpuALLOT  \ 
cpuHERE constant lower2  1 cpuALLOT  \ 
cpuHERE constant lower3  1 cpuALLOT  \ lsB of lower limit

:m |upper-gp0  \ gp0 is negative if gp0 is larger than upper0
               \ quad result in gp0
	[ t push  clrc
         upper3 t mov  gp3 subb  t gp3 mov
        	upper2 t mov  gp2 subb  t gp2 mov
         upper1 t mov  gp1 subb  t gp1 mov
        	upper0 t mov  gp0 subb  t gp0 mov
     t pop ]
m;

:m |gp0-lower  \ gp0 is negative if gp0 is larger than lower0
               \ quad result in gp0
	[ t push  clrc
         gp3 t mov  lower3 subb  t gp3 mov
        	gp2 t mov  lower2 subb  t gp2 mov
         gp1 t mov  lower1 subb  t gp1 mov
        	gp0 t mov  lower0 subb  t gp0 mov
     t pop ]
m;

-: ?uclip   \ ~19 usec
   ie>gp0  |upper-gp0
   gp0 #@ -if drop upper0 # @quad< ie-acc # !quad ; then drop ; 

-: ?lclip   \ ~19 usec
   ie>gp0  |gp0-lower
   gp0 #@ -if drop lower0 # @quad< ie-acc # !quad ; then drop ;

-: /clip  \ pre-load limits for speed   
   0 # @band-table  upper0 # !quad   
   1 # @band-table  lower0 # !quad ;   

:m |?ie-update   
   ie-change? if ?ie-bump ?uclip ?lclip then drop  |ie-transfer m;

\ : (ie-read)   |?ie-update lcd.ie-acc ;
\ : ie-read  begin (ie-read) 10 # ms again ;
\ : ie-test  begin |?ie-update lcd.ie-acc ie-switch 0=if. flutter then again ;
\ : ie-test  0lcd  lcd.ie-acc  begin |?ie-update lcd.ie-acc ie-switch 0=until. ;

-: /ie   |ie-transfer  0ie-acc  /ie-step  /clip ;

here ( *stop) [ swap -  cr .( ie.fs              ) . .( bytes) ]
\ 
0 [if] ------------------------[ revisions ]-----------------------------------
\ 
Date	  By  Comment
======= === ==============================================================
14Mar14 rjn added band limit checking (right way to do it)
17Feb14 rjn modified for strobe (cloned from SUDDS) 
02Apr13 rjn added compile usage, changed most defs. to "no dictionary" 
05May09 rjn added rega+regb increment to |?ie-bump (for VFO)
06Apr09 rjn moved vfo functions to separate file
22Jan09 rjn configure for 410, change initialization
08Jul08 rjn cleanup, rate test 
03Jul08 rjn	original version
\ 
[then] \ ----------------------------------------------------------------------
