\ job.fs -- 850 DDS stroboscope -- 140423rjn
\ 
false   constant tethered
true    constant turnkeyed
false   constant standalone

\ -----[ configure for 850 Dev ]
	$200  constant start        \ Reset vector.  Bootloader at $0000.
	$20B  constant TIM0         \ timer 0 interrupt
   $21B  constant TIM1         \ timer 1 overflow interrupt
   $223  constant RI           \ serial receive interrupt
   $22B  constant TIM2         \ timer 2 overflow interrupt
   $233  constant rom-start    \ start of code ($22b + $08)
   $1fff constant target-size  \ 8K flash
\ 
true constant cs?  \ produce compilation summary?
\ 
\ -----[ load MyForth system ] 
include loader_140220.fs
\ 
\ -----[ define SFRs, generate bootloader image ]
include sfr85x_140422.fs
include bootloader850_140422.fs 
\ 
\ version string is placed here by ver$
rom-start [ 20 + ] org  \ leave room for version string ver$
\ include serial.fs       \ serial I/O, strings
:m " 34 parse here there place here there [ c@ 1 + ] allot m;
here rom-start org  " DSTRO-140423" org  \ version string
\ 
include 25_delays.fs    \ 25 MHz delays
include init.fs         \ chip initialization, I/O primitives
include utils.fs        \ misc. utils -- load before application
\ 
\ -----[ include interpreter(s) ] 
tethered   [if] include mide-tether.fs      [then]
standalone [if] include dacs-standalone.fs  [then]
\ 
\ -----[ load the application ] 
\ 
\ dstro.txt               \ text link to doc file
\ [ cr ]                    \ whitespace for compilation summary
include xors.fs           \ xor macros (e.g., for case statements)
include dstro_lcd16.fs
include memory.fs           \ direct cell, flash & xram memory access
include regs.fs
include xvars.fs          \ variables in xram with flash save/restore
include ie.fs
include dstro_timer0.fs
include rates.fs          \ rate tables
include duty.fs           \ duty cycle table
include multiply.fs       \ multiple byte multiply by a constant
include qdigits.fs
include freqs.fs          \ calculate dds load values
include 9850.fs           \ 9850 DDS driver
include intervals.fs      \ encoder menu intervals
include updates.fs        \ frequency, LCD updates
include dstro_menu.fs     \ lcd menuing system
include dstro_main.fs     \ initialization, go definition
\ include interactive.fs    \ Should come _after_ application for efficiency.
[ cr cr ] 
\ 
\ -----[ patch the reset vector ]
turnkeyed [if]	\ Turnkeyed with go.
	start interrupt : cold stacks go ;      \ patch reset to go 
[else]	        \ Testing with quit.
	start interrupt : cold stacks quit ;
[then]
\ 
\ -----[ select interactive or standalone ]
tethered [if]  \ interactive number entry
	:m # tnumber emit-s m;
	:m ## [ dup 8 rshift $ff and swap $ff and ] # # m;
[then]  
\
standalone [if]  \ standalone - patch dictionary pointer
\ Note: see config.fs -- headers are tacked on (moved) to the end of code by "headers"
        : r   cold ;
        headers ] here [ dict org heads ##p! org ] 
        [ .( heads start at: ) heads .  .(  size: ) ] 
		here [ heads - .  .(  bytes) ]
	here ( *) patch-cold org cold ( *) org  \ patch cold (after end of heads)
[then]
\
\ -----[ report build statistics ]
report
save
[ .( Host stack= ) .s
cr target-size ] here [ - .  .( bytes flash available) cr ]

