\ memory.fs -- access to flash, xram & direct cells -- 01Mar14 rjn
\
] here  ( *start)
\
0 [if] \ -----------------------[ direct cells ]-------------------------------
[then] \ ----------------------------------------------------------------------
\ 
:m |(!cells)  [ 4 push ] 4 #for !+ 4 #next [ 4 pop ] m;
-: (!cells)  |(!cells) ;

:m |!cells   ( ... adr n -)  swap a!  |(!cells)  m;
-: !cells  |!cells ;

:m |(@cells)  [ 4 push ] 4 #for @+ 4 #next [ 4 pop ] m;

:m |@cells   ( adr n - ...)  swap a!  |(@cells)  m;
-: @cells  |@cells ;

\ Note: to save and restore a pent register:
\    pentc # 5 # @cells< .... pentc # 5 # !cells 
-: (@cells<)  [ 4 push ] 4 #for @  [ 1 dec ] 4 #next [ 4 pop ] ;
-: @cells<  ( adr n - ...)  swap |over -1 # + + a!  (@cells<) ;
\ 
1 [if] \ ----------------------------------------------------------------------
\
\ -: msb$   string " > "
\ -: .msb  msb$ ;
\ display in hex left to right (lsb is rightmost, like h.s)
\ : (qh.) ( q --)    h. h. h. h. ;  
\ -: qh.   ( q --)    ( .msb) h. h. h. h. ;
\ 
\ fetch and store with msb on tos (normal)
\ -: @dq   ( n -- dq)   8 # @cells ; \ lsb on tos
-: @dq<  ( n -- dq)   8 # @cells< ;  \ msb on tos
-: !dq   ( dq n - )   8 # !cells ;
\ -: .dq   ( n --)   @dq< qh. qh. ;

-: @quad   ( n - q)    4 # @cells  ; \ result: lsB on tos
-: @quad<  ( n - q)    4 # @cells< ; \ result: msB on tos
-: !quad  ( q n -)     4 # !cells  ; \ msb on tos
\ -: .quad  ( q n -)      @quad< qh. ;

\ -: .pent  ( p n -)   5 # @cells< h. qh. ;     
\ 
[then] \ ----------------------------------------------------------------------
\ 
1 [if] \ ----------------------------------------------------------------------
:m |!4  ( n1 n2 n3 n4 - )   4 # |(!cells) m;
-: !4  |!4 ;
-: |@4  ( - n1 n2 n3 n4)    4 # |(@cells) ;
-: @4  |@4 ;

-: set4  ( n1 n2 n3 n4 adr -)  4 #  !cells ;
-: get4  ( adr - n n1 n2 n3)   4 #  @cells ;
-: get4< ( adr - n3 n2 n1 n)   4 #  @cells< ;   

-: zero4  ( adr -)  a!  0 ## 0 ##  !4 ;
-: zero5  ( adr -)  a!  0 ## 0 ## 0 #  5 #  |(!cells) ;

\ -: (.cells)   [ 4 push ] 4 #for @+ h. 4 #next [ 4 pop ] ;
\ -: .cells  ( adr n -)  swap a!  (.cells) ;
\ : .4h   4 #  (.cells)  ; \ set "a" first!
\
[then] \ ----------------------------------------------------------------------
\  
\ 
0 [if] \ ------------------------[ 850 flash ]---------------------------------
\ 
1. For the 850, end of flash is $1fff (8K), the flash configuration block is 
   put at $01c0 (7168), the next to last sector before the end of flash.
   WITH THIS CHOICE,THE ACTUAL NUMBER OF FLASH BYTES LEFT IS 1K LESS THAN 
   SHOWN ON THE "bytes available" ON THE COMPILATION DISPLAY.
\ 
[then] \ ----------------------------------------------------------------------
\ 
: dnegate swap invert swap invert 1 ## |d+ ;  \ from utils.fs
-: p-  1 ## dnegate |p |d+ p! ;
\ 
\ returns four bytes in the same order as stored in flash (e.g., lsb on tos)
-: @qflash  ( d - q)   p!  |@p+ |@p+ |@p+ |@p ;

-: @qflash<  ( d - q)  \ for number stored in normal order, msb first, lsb last 
    4 ## |d+ p!  \ load dptr with pointer one beyond last byte
    4 #  [ 5 push ] 5 #for p- |@p 5 #next [ 5 pop ]  ;
\ 
-: ai>qadr  ( d i - d')   2* 2* 0 # |d+ ;
\ usage example:
\ -: >fxtable  ( n - d)  push fxtable ## pop ai>qadr ; \ index > xtable adr

-: ai>adr  ( d i - d')   0 # |d+ ;
-: @flash  ( d - n)   p! |@p ;
\ 
\ 
\ ----------------------------[ config block ]---------------------------------
\ 
\ flash blocks are 512 bytes, xram is 256 bytes
\ 
$1e00 constant config-block \ last block starts at $1e00
\ 
\ In erase mode, writing any byte to the block erases it.  Write $ff  
-: (erase-config)    config-block ##p! $ff # +erase !x -write ;
\ : ec (erase-config) ;  \ debug
\ SL says that flash lasts longer with two erases before a write
-: erase-config  (erase-config) (erase-config) ;

\ fwrite only works if the block is first erased
-: !f+  ( n -)   +write !x+ -write ;
-: !f   ( n -)   +write !x -write ;
:m fwrite  ( n -)  5 #for +write !x+ -write 5 #next m;
:m fwrite-dq    ( a -)   8 # @cells  8 # fwrite m; 
:m fwrite-quad  ( a -)   4 # @cells  4 # fwrite m;  \ lsb written first
\ 
\ always works
-: @f  ( - n)   |@p ;
:m fread  ( n - n ... n')   5 #for |@p+ 5 #next m;
:m fread-dq    ( a -)   8 # fread m; 
:m fread-quad  ( a -)   4 # fread m;

[then] \ ----------------------------------------------------------------------
\ 
0 [if] \ --------------------[ display config block ]--------------------------

\ 
\ ----- debug
\ : 0test  $77ff ##p! $a5 # !f ;
\ : 1test  config-block ##p!  $5a # !f  p+ p+ $00 # !f p+ p+  $a5 # !f ;

-: (.cfg)  ( n -)  \ display n groups of 16, assumes p is set
            [ 5 push  6 push  7 push ]
   5 #for
      cr p dh. space
      4 #  7 #for 
         space 4 #  6 #for |@p+ h. 6 #next 
      7 #next
   5 #next  [ 7 pop  6 pop  5 pop ] ;

: .cfg   config-block ##p! 64 # (.cfg) cr ;

[then] \ ----------------------------------------------------------------------
\ 
0 [if] \ --------------------------[ example ]---------------------------------
\ 
\ ----- hold 
config-block constant #f-hold
-: save-hold   #f-hold ##p!  hold0 #  fwrite-quad ;
-: @f-hold  ( - lsb ... msb)   #f-hold ##p!  fread-quad ;
-: /hf  @f-hold  !hold ;  \ init hold from flash
\
\ ----- hold defaults
\ -: hold-def ; \ label for looking at defaults
here constant hold-default
$37 , $86 , $00 , $00 ,  \ 1000 Hz, lsb written first
-: %h  hold-default ##p!  fread-quad  !hold ; \ init hold from default

[then] \ ----------------------------------------------------------------------
\ 
\ 
0 [if] \ ------------------------[ 850 xram ]----------------------------------

1. On the 850 chip, there is 256 bytes of xram.
2. The xram can be accessed a byte at a time with the kernel
   words !x, !x+, @x and @x+ .  These assumed that the data pointer, p, is 
   is set to the two-byte xram address.  Thus, xram addresses begin at
   $0000 and end at $00ff .
\ 
[then] \ ----------------------------------------------------------------------
\ 
\ 
-: @qx  ( d - q)  p! @x+ @x+ @x+ @x ;  \ if stored msb first, returns lsb first
-: @qx<  ( d - q)  \ for numbers stored in normal order, msb first, lsb last 
\ returns a quad in normal order (msb first)
   4 ## |d+ p!  \ load dptr with pointer one beyond last byte
    4 #  [ 5 push ] 5 #for p- @x 5 #next [ 5 pop ]  ;

-: !qx  ( q d -)   p! !x+ !x+ !x+ !x ;

-: !qx<  ( q d - )  \ ! quad to xram given xram adr, store in lsb->msb order
   4 ## |d+ p!  \ load dptr with pointer one beyond last byte
   4 #  [ 5 push ] 5 #for p- !x 5 #next [ 5 pop ]  ; \ fixed error 01Mar14rjn   

-: !xram  ( n d -)   p!  !x ;
-: @xram  ( d - n)   p!  @x ;
\ : xtest ( - q)  $dd #  $cc #  $bb #  $aa # ( msb) 0 ## !qx  0 ## @qx< ;
\   
here ( *stop) [ swap -  cr .( memory.fs          ) . .( bytes) ]
\ 
0 [if] \ ------------------------[ revisions ]--------------------------------- 

 
Date	  By  Comment
=========== ===================================================================
01Mar14 rjn fixed error in !qx< (don't use !x+).  Also editied for 850 chip
21Apr13 rjn initial verson (replaces flash and xram source files)
\ 
[then] \ ----------------------------------------------------------------------
