\ qdigits.fs -- display quad in hold as decimal digits -- 04Mar14 rjn
\ 
]  here ( *start)
\ 
\ -----[ decimal digit extraction ]
\ 
0 [if] \ ----------------------[ Decimal Conversion ]--------------------------

1.    ----- Decimal/Hex equivalents -----

 	   Decimal      Hexadecimal    
        =============   ==============
      100,000,000,000   17 48 76 E8 00 (not needed)
       10,000,000,000   02 54 0B E4 00 (not needed)
        1,000,000,000   00 3B 9A CA 00
          100,000,000   00 05 F5 E1 00            
           10,000,000   00 00 98 96 80
            1,000,000   00 00 0F 42 40
              100,000   00 00 01 86 A0
               10,000   00 00 00 27 10             
                1,000   00 00 00 03 E8
                  100   00 00 00 00 64
                   10   00 00 00 00 0A

2. The value to be converted is assumed to be in the holding register,
   hold, a quad register.

[then] \ ----------------------------------------------------------------------
\ 
\ -----[ Add, Subtract decimal scaling to/from hold ]
\ 
\ use gp registers to hold the current digit multiplier
\ 
-: |hold+dmult
	[ t push  clrc
         hold3 t mov  gp3 addc  t hold3 mov
         hold2 t mov  gp2 addc  t hold2 mov
        	hold1 t mov  gp1 addc  t hold1 mov
        	hold0 t mov  gp0 addc  t hold0 mov
     t pop ] ;

-: |hold-dmult
	[ t push  clrc
         hold3 t mov  gp3 subb  t hold3 mov
         hold2 t mov  gp2 subb  t hold2 mov
        	hold1 t mov  gp1 subb  t hold1 mov
        	hold0 t mov  gp0 subb  t hold0 mov
     t pop ] ;

0 [if] \ -------[ get digit multipliers using case statement ]-----------------
\ 
\ table method much better -- saves 120 bytes & probably faster
\ 
\ ----- load the constants for each decimal multiplier
\ -: !digitx   $00 # $CA # $9A # $3B #  ;
\ -: !digity   $00 # $E1 # $F5 # $05 #  ; 
-: !digit    $80 # $96 # $98 # $00 #  ; 
-: !digit1   $40 # $42 # $0F # $00 #  ; 
-: !digit2   $A0 # $86 # $01 # $00 #  ; 
-: !digit3   $10 # $27 # $00 # $00 #  ;
-: !digit4   $E8 # $03 # $00 # $00 #  ;
-: !digit5   $64 # $00 # $00 # $00 #  ;
-: !digit6   $0A # $00 # $00 # $00 #  ;
-: !digit7   $01 # $00 # $00 # $00 #  ;

-: (ndigit)  ( index - q)  \ based on index, get digit multiplier
          0=if drop !digit   ; then
   |1xor  0=if drop !digit1  ; then  |1xor 
   |2xor  0=if drop !digit2  ; then  |2xor
   |3xor  0=if drop !digit3  ; then  |3xor
   |4xor  0=if drop !digit4  ; then  |4xor
   |5xor  0=if drop !digit5  ; then  |5xor
   |6xor  0=if drop !digit6  ; then  |6xor
   |7xor  0=if drop !digit7  ; then  drop
;

-: ndigit  ( index -)   (ndigit)  gp0 # !quad ;
\
[then] \ ----------------------------------------------------------------------
\ 
1 [if] \ -------------[ get digit multipliers from table ]---------------------
\ 
\ note: now use @qflash defined in send-flash.fs -- 21Apr13 rjn
\ returns four bytes in the same order as stored in flash (e.g., lsb on tos)
\ -: @qflash  ( d - q)   p!  |@p+ |@p+ |@p+ |@p ;
\ : .qtable   ( table-adr -)       p!  4 #  5 #for |@p+ h. 5 #next ;
\ 
here constant digit-table
\ lsb ------------- msb    \ note: can't display more than 9,999,999,999
\  $00 , $ca , $9a , $3b ,  \ 1,000,000,000
\  $00 , $e1 , $f5 , $05 ,  \ 100,000,000  
  $80 , $96 , $98 , $00 ,
  $40 , $42 , $0F , $00 , 
  $A0 , $86 , $01 , $00 , 
  $10 , $27 , $00 , $00 ,
  $E8 , $03 , $00 , $00 ,
  $64 , $00 , $00 , $00 ,
  $0A , $00 , $00 , $00 ,
  $01 , $00 , $00 , $00 ,

8 constant #entries  \ change this when adding, deleting table entries

\ note: index must be less than 64 (table of 256 bytes)
\ 
\ -: ndigit  ( index -)  \ load gp0 from table
\  2* 2* 0 # digit-table ##  |d+ @qtable  gp0 # !quad ;

-: ai>qadr  ( d i - d')   2* 2* 0 # |d+ ;

-: ndigit  ( index -)  \ load gp0 from table
   push digit-table ##  pop  ai>qadr @qflash  gp0 # !quad ;
\ 
[then] \ ----------------------------------------------------------------------
\ 
-: (qdigit)  ( - n)  
   1 # negate dup begin drop |hold-dmult 1+ hold0 #@ -until drop |hold+dmult ;

\ note: can't use gp8 -- fxtable temp index

:m 0qdigit-regs    0 # gp10 #!  0 # gp11 #!  m;  \ zero out qdigit temp regs
:m -lead    $ff # gp10 #! m; \ true= not a leading zero (don't zap it) 

\ -: ?#6  [ gp11 inc ]  gp11 #@ 6 # xor 0=if [ char . ] # lcd then drop ;
-: ?#5  gp11 #@ 5 # xor 0=if [ char . ] # lcd then drop ;
-: ?#6  gp11 #@ 6 # xor 0=if [ char . ] # lcd then drop ;
-: ?#7  gp11 #@ 7 # xor 0=if [ char . ] # lcd then drop ;

-: ?leader  ( n -)   gp10 #@ if drop lcd.digit ; then drop
   gp11 #@ #entries # =if drop lcd.digit ; then drop drop _lcd ;  \ displays last zero

-: ?lcd.digit  ( n -)  \ display digit, no leading zeroes (except last zero)  
   [ gp11 inc ] dup 0=if drop ?leader ; then drop -lead  lcd.digit ;

\ no serial 
\ -: ?sleader  ( n -)   gp10 #@ if drop digit ; then drop drop space ;
\ -: ?.digit  ( n -)   dup 0=if drop ?sleader ; then drop -lead  digit ;

-: ?lcd.1digit  ( n -)   ?#7  ?lcd.digit ;
-: ?lcd.2digit  ( n -)   ?#6  ?lcd.digit ;
-: ?lcd.3digit  ( n -)   ?#5  ?lcd.digit ;
\ 
0 [if] \\\\\\\\\\\\\\\\\\\\\ serial version \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\ 
-: ?qdigit  ( n -)  \ 0 = 8 digs, suppress leading zeroes
                    \ 1 = 8 digs, suppress leading zeroes, with kHz marker 
                    \ 2 = 8 digs, suppress leading zeroes, with 0.1 Hz marker
                    \ 3 = 8 digs, serial
          0=if drop ?lcd.digit  ; then
   |1xor  0=if drop ?lcd.3digit ; then  |1xor
   |2xor  0=if drop ?lcd.1digit ; then  |2xor 
   |3xor  0=if drop ?.digit     ; then  drop ;
\ 
[then] \ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\   
\ 
-: ?qdigit  ( n -)  \ 0 = 8 digs, suppress leading zeroes
                    \ 1 = 8 digs, suppress leading zeroes, with kHz marker 
                    \ 2 = 8 digs, suppress leading zeroes, with 0.1 Hz marker
                    \ 3 = 8 digs, suppress leading zeroes, with 0.01 Hz marker
          0=if drop ?lcd.digit  ; then
   |1xor  0=if drop ?lcd.3digit ; then  |1xor
   |2xor  0=if drop ?lcd.1digit ; then  |2xor
   |3xor  0=if drop ?lcd.2digit ; then  drop ;
\ 
-: (do-qdigits)  \ various routines, driven by a selector.  Select routine with gp15
   0qdigit-regs  ( uses gp10, 11)
   [ 4 push ]   
        0 #  #entries #  4 #for 
           dup ndigit (qdigit) gp15 #@ ?qdigit  1+ 
        4 #next  drop  
   [ 4 pop ] ; 

-: do-qdigits  @hold< (do-qdigits) !hold ;  

-: lcd.8   \ display 8 hold digits on LCD, suppress leading zeros
   0 # gp15 #!  do-qdigits ;

-: (lcd.8)    0 # gp15 #!  (do-qdigits) ;  \ lcd.8, doesn't preserve hold
-: (lcd.83)   1 # gp15 #!  (do-qdigits) ;  \ lcd.83, doesn't preserve hold
-: lcd.83     1 # gp15 #!  do-qdigits   ;  \ LCD show 8 hold digits in "kHz" format
-: lcd.81     2 # gp15 #!  do-qdigits   ;  \ LCD show 8 digits in 0.1 Hz format
-: lcd.82     3 # gp15 #!  do-qdigits   ;
  
\ no serial
\ -: s.8     3 # gp15 #!  do-qdigits ;  \ serial display of hold digits
\ 
1 [if] \ ----------------------[ qdigit test ]---------------------------------
\ 
-: qtest    $02d2 ##  $4996 ## !hold  (lcd.8) ;
\ 
[then] \ ----------------------------------------------------------------------
\ 
\ 
0 [if] \ --------------------[ Offset Display ]-------------------------------
\ 
1. This subtracts a fixed frequency from the actual frequency before 
   displaying.  For example, the receive range might be 6.9 to 7.4 MHz
   but the injection frequency ranges from 15.9 to 16.4 MHz.  Thus,
   9 MHz must be subtracted from the injection frequency to display
   the actual receive frequency.
\ 
[then] \ ----------------------------------------------------------------------
\ 
\ 
0 [if] \ -------------------[ band offset table ]------------------------------
\ 
here constant offset-table
\ lsb ------------- msb
  $40 , $54 , $89 , $00 ,  \ 9 MHz
\  $1c , $5a , $89 , $00 ,  \ 9 MHz + 1.5 khz (9,150.000 kHz) -- 27May13 rjn
\  $64 , $4e , $89 , $00 ,  \ 9 Mhz - 1.5 khz (8,850.000 kHz) -- 27May13 rjn

-: @offset-table  ( index - q) \ get quad from offset table
  push offset-table ## pop ai>qadr @qflash ;

-: hold-gp4  \ subtract offset from hold, result in hold
   [ t push  clrc
      hold3 t mov  gp7 subb  t hold3 mov
      hold2 t mov  gp6 subb  t hold2 mov
      hold1 t mov  gp5 subb  t hold1 mov
      hold0 t mov  gp4 subb  t hold0  mov
   t pop ] ;   

-: hold+gp4  \ subtract offset from hold, result in hold
   [ t push  clrc
      hold3 t mov  gp7 addc  t hold3 mov
      hold2 t mov  gp6 addc  t hold2 mov
      hold1 t mov  gp5 addc  t hold1 mov
      hold0 t mov  gp4 addc  t hold0  mov
   t pop ] ;

-: hold-temp4  \ result in hold
   [ t push  clrc
      hold3 t mov  temp7 subb  t hold3 mov
      hold2 t mov  temp6 subb  t hold2 mov
      hold1 t mov  temp5 subb  t hold1 mov
      hold0 t mov  temp4 subb  t hold0  mov
   t pop ] ;  

-: temp4-hold  \ result in hold
   [ t push  clrc
      temp7 t mov  hold3 subb  t hold3 mov
      temp6 t mov  hold2 subb  t hold2 mov
      temp5 t mov  hold1 subb  t hold1 mov
      temp4 t mov  hold0 subb  t hold0  mov
   t pop ] ;  

:m |hold-temp4  \ result in hold
   [ t push  clrc
      hold3 t mov  temp7 subb  t hold3 mov
      hold2 t mov  temp6 subb  t hold2 mov
      hold1 t mov  temp5 subb  t hold1 mov
      hold0 t mov  temp4 subb  t hold0  mov
   t pop ] m;  

\ -: hold-offset   @cal-offset  temp4 # !quad  |hold-temp4 ; \ result in hold

-: hold+temp4  \ result in hold
   [ t push  clrc
      hold3 t mov  temp7 addc  t hold3 mov
      hold2 t mov  temp6 addc  t hold2 mov
      hold1 t mov  temp5 addc  t hold1 mov
      hold0 t mov  temp4 addc  t hold0 mov
   t pop ] ;  
\ 
[then] \ ----------------------------------------------------------------------
\ 
0 [if] \ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\ 
\ eliminated sideband offset -- 27May13 rjn
-: hold-9mhz   ( @side) 0 # @offset-table  gp4 # !quad  hold-gp4 ;
-: hold+9mhz   ( @side) 0 # @offset-table  gp4 # !quad  hold+gp4 ;

-: +cal-offset   @cal-offset  gp4 # !quad  hold+gp4 ;
-: apply-offset   ;

-: ?lcd-offset  @band   \ note: results in hold
          0=if drop hold-9mhz ; then         \ 80M
   |1xor  0=if drop hold-9mhz ; then  |1xor  \ 40M
   |2xor  0=if drop hold-9mhz ; then  |2xor  \ 20M
   |3xor  0=if drop hold+9mhz ; then  |3xor  \ 15M
   |4xor  0=if drop hold+9mhz ; then  drop ; \ 10M
\   
[then] \ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

-: (?lcd.freq)   (lcd.8) ;

\ -: ?lcd.freq   @hold<  lcd.8  !hold ;  \ for vfo
-: ?lcd.freq   @hold<  lcd.82  !hold ;  \ for vfo

-: hold>freq  @hold< freq # !quad ;
:m 60>scale  0scale $3c # scale3 #! m;
-: prod>hold   prod # @quad<  hold0 # !quad ; 

-: ?lcd.rpm  
   @hold<
      ( hold contains frequency value loaded from ie)
      0freq  hold>freq  60>scale  multiply ( result in prod)
      prod>hold  lcd.82
   !hold ;
\ 
0 [if] \ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

-: 'h&t  string " hold&temp: "
-: .hold&temp   cr 'h&t  \ debug
  @hold<  h. h. h. h. space space space temp4 # @quad< h. h. h. h. ;

-: ?dif.freq  \ cal offset displays on line 1
   hold-temp4  @hold<  #caltemp # !qmxtable  \ temporarily save offset 
                line1  [ char + ] # lcd  
   hold0 #@ -if line1  [ char - ] # lcd  hold+temp4 temp4-hold then 
       drop (lcd.8) ;  \ for cal
\ 
[then] \ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\ 
here ( * stop) [ swap -  cr .( qdigits.fs         ) . .( bytes) ]
\ 
\ 
0 [if] \ ------------------------[ revisions ]---------------------------------
\ 
Date	  By  Comment
======= === ==============================================================
04Mar14 rjn added rpm multiply, patched out offset code
23Feb14 rjn patched out serial I/O definitions
22Feb14 rjn re-added ?lcd.freq from SUDDS version
18Feb14 rjn slight changes from SUDDS version for STROBE application.
02May13 rjn updated dif display for cal, display last zero 
23Apr13 rjn added selector for add/subract offset (?lcd-freq)
21Apr13 rjn changed ndigit to use ai>qadr
09Apr13 rjn changed hold references (e.g., hold0 vs. hold)
08Apr13 rjn new version for SEND application
\ 
[then] \ ----------------------------------------------------------------------
