\ regs.fs -- strobe registers -- 17Feb14 rjn
\
] ( target forth)  here  ( start marker)
\ 
\ -----[ gp -- double quad gp cells or two quad cells, gp0 and gp4 ]
\  
cpuHERE constant gp0 16 cpuALLOT  \ gp0 is MSB, gp 7 + is LSB
\ 
:m gp1   [ gp0 1 + ] m;
:m gp2   [ gp0 2 + ] m;
:m gp3   [ gp0 3 + ] m;

:m gp4   [ gp0 4 + ] m;
:m gp5   [ gp0 5 + ] m;
:m gp6   [ gp0 6 + ] m;
:m gp7   [ gp0 7 + ] m;

:m gp8   [ gp0 8 +  ] m;
:m gp9   [ gp0 9 +  ] m;
:m gp10  [ gp0 10 + ] m;
:m gp11  [ gp0 11 + ] m;

:m gp12  [ gp0 12 +  ] m;
:m gp13  [ gp0 13 +  ] m;
:m gp14  [ gp0 14 + ] m;
:m gp15  [ gp0 15 + ] m;

\ 
\ 
:m |gp4-gp0  \ gp4 negative if gp0 is larger than gp4
             \ quad result in gp4
	[ t push  clrc
         gp7 t mov  gp3 subb  t gp7 mov
        	gp6 t mov  gp2 subb  t gp6 mov
         gp5 t mov  gp1 subb  t gp5 mov
        	gp4 t mov  gp0 subb  t gp4 mov
     t pop ]
m;
\ 
:m |gp0-gp4  \ gp4 is negative if gp0 is smaller than gp4
             \ quad result in gp4
	[ t push  clrc
         gp3 t mov  gp7 subb  t gp7 mov
        	gp2 t mov  gp6 subb  t gp6 mov
         gp1 t mov  gp5 subb  t gp5 mov
        	gp0 t mov  gp4 subb  t gp4 mov
     t pop ]
m;

:m gp0>gp4	[  gp3 gp7 mov  gp2 gp6 mov  gp1 gp5 mov  gp0 gp4 mov ] m;
\ 
\ 
\ ---------------------[ frequency holding register ]--------------------------
\ 
cpuHERE constant hold0  1 cpuALLOT  \ msB of 32-bit freq. word
cpuHERE constant hold1  1 cpuALLOT  \ 
cpuHERE constant hold2  1 cpuALLOT  \ 
cpuHERE constant hold3  1 cpuALLOT  \ lsB of 32-bit freq. word
\
\ -----------------------[ phase holding register ]----------------------------
\ 
cpuHERE constant phold  1 cpuALLOT  \ re-enabled 23Jan13 rjn
\  
-: !hold   ( q -)   hold0 # !quad  ;
-: @hold<  ( - q)   hold0 # @quad< ;
\ 
\ -----[ temp -- double quad temporary register ]
\ 
\ used for temporary saves
\ 
cpuHERE constant temp  8 cpuALLOT  \ temp is MSB, temp 7 + is LSB
\ 
:m temp1  [ temp 1 + ] m;
:m temp2  [ temp 2 + ] m;
:m temp3  [ temp 3 + ] m;
:m temp4  [ temp 4 + ] m;
:m temp5  [ temp 5 + ] m;
:m temp6  [ temp 6 + ] m;
:m temp7  [ temp 7 + ] m;
\
:m !temp  ( n1 n2 n3 n4 n5 n6 n7 n8 - )   temp #  !dq m;
-: 0temp      0 ##  0 ##  0 ##  0 ##  temp # !dq   ;
-: 0temp-msb  0 ##  0 ##              temp # !quad ;
-: @temp-lsb  temp4 # @quad ;
-: !temp-lsb  temp4 # !quad ;
\
\ 
\ ------------------------[ a frequency register ]-----------------------------
\ 
cpuHERE constant afreq   1 cpuALLOT  \ msb of 32-bit freq. word (sent last)
cpuHERE constant afreq1  1 cpuALLOT  \ 
cpuHERE constant afreq2  1 cpuALLOT  \ 
cpuHERE constant afreq3  1 cpuALLOT  \ lsb of 32-bit freq. word (sent first)
\ 
\ --------------------------[ a phase register ]-------------------------------
\ 
\ cpuHERE constant aphase  1 cpuALLOT
\ 
\ ---------------------[ scale register for A DDS ]----------------------------
\ 
cpuHERE constant ascale   1 cpuALLOT  \ msb
cpuHERE constant ascale1  1 cpuALLOT  \ 
cpuHERE constant ascale2  1 cpuALLOT  \ 
cpuHERE constant ascale3  1 cpuALLOT  \ lsb
\ 
\ ---------------------[ address, mask registers ]-----------------------------
\ 
\ cpuHERE constant adr   1 cpuALLOT
\ cpuHERE constant mask  1 cpuALLOT
\ cpuHERE constant gmask 1 cpuALLOT
\ 
\ --------------------------[ open drain flag ]--------------------------------
\ 
\ cpuHERE constant od?   1 cpuALLOT  \ false = open drain, true = push pull
\ 
\ ----------------------------[ 9851 flag ]------------------------------------
\ 
\ cpuHERE constant 9851?   1 cpuALLOT  \ true=9851 w/PLL, false=9850
\ 
\ -----------------------------[ last menu choice ]----------------------------
\ 
cpuHERE constant ~last 1 cpuALLOT  \ last menu option displayed (temp)

:m /last  $ff # ~last #! m;
-: ?shown  ( n - n')  \ this menu item already displayed?
   dup ~last #@ negate + 0=if drop drop $ff # ; then drop dup ~last #! ;
\ 
\ 
\ ----------------------------[ backup to prev menu ]--------------------------
\ 
cpuHERE constant ~back? 1 cpuALLOT  \ true = return to prev. menu

-: /back      0 # ~back? #! ;
-: xback  $ff # ~back? #! ;  \ return to previous menu
-: back?  ( - n)   ~back? #@ ;
-: 'back     lstring " <---"
-: .back  line2 4 # n_lcd 'back 8 # n_lcd ;
\ 

here ( stop marker) [ swap -  cr .( regs.fs            ) . .( bytes) ]
\
\
0 [if] ------------------------[ revisions ]-----------------------------------
\ 
Date	   By  Comment
=======	=== ===================================================================
24Feb14  rjn modified further for dstro application
17Feb14  rjn define registers for strobe application
\ 
[then] \ ----------------------------------------------------------------------


